<#-- Functions -->
<#function not_contains compare compare_to>
    <#local result = []>
    <#list compare as thing>
        <#if !compare_to?seq_contains(thing)>
            <#local result = result + [thing]>
        </#if>
    </#list>
    <#return result>
</#function>
<#-- Macros -->
<#macro create_value_list values>
    <#list values as value><#t>
        ${value}<#if value_has_next>, </#if><#t>
    </#list><#t>
</#macro>
<#macro create_column_match_list cols>
    <#list cols as column><#t>
        ${column}=B.${column}<#if column_has_next>, </#if><#t>
    </#list><#t>
</#macro>
<#macro create_column_list_with_prefix pre cols>
    <#list cols as column><#t>
        ${pre}${column}<#if column_has_next>, </#if><#t>
    </#list><#t>
</#macro>
<#macro create_column_match_list a b sep cols>
    <#list cols as column><#t>
        ${a}${column} = ${b}${column}<#if column_has_next>${sep}</#if><#t>
    </#list><#t>
</#macro>
<#macro create_value_alias_list values cols>
    <#list values as value><#t>
        <#assign counter=value?counter>
        <#assign col=cols[counter-1]>
        ${value} AS ${col}<#if value_has_next>, </#if><#t>
    </#list><#t>
</#macro>
<#macro create_column_list cols>
    <#list cols as column><#t>
        ${column}<#if column_has_next>, </#if><#t>
    </#list><#t>
</#macro>
<#assign all_columns = columns?split(", ") >
<#assign match_columns = mergeMatchColumns?split(", ") >
<#assign non_match_columns = not_contains(all_columns, match_columns) >
<#-- Output below -->
MERGE INTO ${catalog}${catalogSeparator}${schema}${schemaSeparator}${table} A USING
(SELECT <@create_value_alias_list values=rowValues[0] cols=all_columns/>${anon_table}) B ON (<@create_column_match_list a='A.' b='B.' sep=' AND ' cols=match_columns/>)
WHEN NOT MATCHED THEN INSERT (<@create_column_list cols=all_columns/>) VALUES (<@create_column_list_with_prefix pre='B.' cols=all_columns/>)
WHEN MATCHED THEN UPDATE SET <@create_column_match_list a='' b='B.' sep=", " cols=non_match_columns/>${statementSeparator}
